/**
 *  
 
 Copyright (c) 2009 Piotr Kilczuk <p.kilczuk@neumea.pl>
 
 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the "Software"), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 * 
 */

var RescuetimeFirefoxExtension = function () {
	
	return {
		
		/**
		 * Stores the interval object
		 * 
		 */
		interval: null,
		
		/**
		 * Launches updating URL every second
		 * 
		 */
		launchInterval: function () {
			RescuetimeFirefoxExtension.interval = window.setInterval(function () {
				RescuetimeFirefoxExtension.writeToFile(content.location.href);
			}, 1000);
		},
		
		/**
		 * Updates status bar value
		 * 
		 */
		updateStatusBar: function (value) {
			var statusBar = document.getElementById('hello-world-url');
			statusBar.setAttribute('value', value);
			return true;
		},
		
		/**
		 * Writes current url to file
		 * 
		 */
		writeToFile: function (url) {
			
			// instantinate some stuff
			var file = Components.classes["@mozilla.org/file/local;1"]
			           .createInstance(Components.interfaces.nsILocalFile);
			var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
					       .createInstance(Components.interfaces.nsIFileOutputStream);
			
			// initialize file write op
			// @see: http://jsdoodnauth.wordpress.com/2008/11/26/xul-file-io-write-files/
			file.initWithPath('~/.mozilla/firefox/currentURL');
			foStream.init(file, 0x02 | 0x08 | 0x20, 00666, 0);
			
			foStream.write(url, url.length);
			foStream.close();
		
		}
		
	};
	
}();

RescuetimeFirefoxExtension.launchInterval();