import sys
import os
import traceback
import shutil
from subprocess import Popen, PIPE

from setuptools import setup, find_packages

try:
    version = Popen(["bzr", "revno"], stdout=PIPE).communicate()[0]
    version = version.rstrip()
except OSError:
    version = 'unknown'

setup(
	name = "RescueTimeUploader",
	packages = find_packages(),
	version = version,
	package_data = {
		'RescueTimeUploader': ['extensions/*/*', 'images/*'],
		'': ['firefox_extension/rescuetime_uploader.xpi', 'epiphany_extension']
	},

	entry_points = {
		'console_scripts': [
			'rescuetime_linux_uploader = RescueTimeUploader.entrypoints:command_line',
			'rescuetime_linux_uploader_gnome_panel_controller = RescueTimeUploader.entrypoints:gnome_panel_controller',
			'rescuetime_linux_uploader_gnome_panel_notifier= RescueTimeUploader.entrypoints:gnome_panel_notifier',
			'rescuetime_linux_uploader_gnome_panel_window = RescueTimeUploader.entrypoints:gnome_panel_window' # For debugging purposes
		    ]
	}
)

try:
	if 'install' in sys.argv or\
	   'develop' in sys.argv:
		shutil.copy('gnome_applet/rescuetime_16.png','/usr/share/icons/hicolor/16x16/rescuetime.png')
		shutil.copy('gnome_applet/rescuetime_22.png','/usr/share/icons/hicolor/22x22/rescuetime.png')
		shutil.copy('gnome_applet/rescuetime_32.png','/usr/share/icons/hicolor/32x32/rescuetime.png')
		shutil.copy('gnome_applet/rescuetime_48.png','/usr/share/icons/hicolor/48x48/rescuetime.png')
		shutil.copy('gnome_applet/rescuetime_48.png','/usr/share/pixmaps/rescuetime.png')
		shutil.copy('gnome_applet/rescuetime_tracker.server','/usr/lib/bonobo/servers/')
		shutil.copy('gnome_applet/rescuetime_notifier.server','/usr/lib/bonobo/servers/')
except:
	print "Failed to install icons and bonobo server."
	traceback.print_exc()
